'''
Copyright (C) 2021  Alexander "PapaTutuWawa"

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
'''
from mira.module import BaseModule

NAME = 'test'

class TestModule(BaseModule):
    __instance = None

    @staticmethod
    def get_instance(base, **kwargs):
        if TestModule.__instance == None:
            TestModule(base, **kwargs)

        return TestModule.__instance
    
    def __init__(self, base, **kwargs):
        if TestModule.__instance != None:
            raise Exception('Trying to init singleton twice')

        super().__init__(base, **kwargs)
        TestModule.__instance = self

    async def on_command(self, cmd, msg):
        greeting = self.get_option('greeting', 'OwO, %%user%%!').replace('%%user%%', str(msg.from_.bare()))
        self.send_message(msg.from_, greeting)

def get_instance(base, **kwargs):
    return TestModule.get_instance(base, **kwargs)
